function B = gramSchmidt(A, scalar_prod)
    [n, m] = size(A);
    B = zeros(n, m);
    for k = 1:m
        v = A(:,k);
        for j = 1:k-1
            v = v - scalar_prod(B(:,j), A(:,k)) * B(:,j);
        end
        B(:,k) = v / sqrt(scalar_prod(v, v));
    end

end

